C     BLOCK DATA
C         DEFINITIONS OF VALUES IN COMMON ARRAYS
C
C     KBL=BLANK     MXCH=6    MXLI=8191      N15B=8192
C     NPAGE=0       MXLINE=55      LINE=56(=MXLINE+1)
C
C     ARRAY  KDIG   - NUMERIC CHARACTERS
C        0    1    2    3    4    5    6    7    8    9
C       (1)  (2)  (3)  (4)  (5)  (6)  (7)  (8)  (9) (10)
C
C     ARRAY  KABC   - ALPHA CHARACTERS
C        A    B    C    D    E    F    G    H    I    J    K    L    M
C       (1)  (2)  (3)  (4)  (5)  (6)  (7)  (8)  (9) (10) (11) (12) (13)
C        N    O    P    Q    R    S    T    U    V    W    X    Y    Z
C      (14) (15) (16) (17) (18) (19) (20) (21) (22) (23) (24) (25) (26)
C
C     ARRAY  KSPK   - SPECIAL CHARACTERS
C        =    ,    (    /    )    +    -    *    .    $   8/4   &    '
C       (1)  (2)  (3)  (4)  (5)  (6)  (7)  (8)  (9) (10) (11) (12) (13)
C
C     ARRAY  KEY
C         SYMBOL    DEFINITION
C     ( 1)-'  ' (BLANK) - SIMPLE REFERENCE
C     ( 2)-' =' VARIABLE APPEARS LEFT OF = IN AN ARITHMETIC STATEMENT
C     ( 3)-' *' STATEMENT NUMBER IS DEFINED HERE, OR THE VARIABLE IS
C               USED AS A SUBROUTINE, FUNCTION, OR COMMON ARRAY NAME
C     ( 4)-'AG' VARIABLE APPEARS AS AN ARGUMENT IN A SUBROUTINE, ENTRY,
C               OR FUNCTION STATEMENT, OR IN A CALL STATEMENT
C     ( 5) 'CO' VARIABLE APPEARS IN A COMMON STATEMENT
C     ( 6) 'CX' VARIABLE APPEARS IN A COMPLEX STATEMENT
C     ( 7)-'DA' VARIABLE APPEARS IN A DATA STATEMENT
C     ( 8) 'DB' VARIABLE APPEARS IN A DOUBLE PRECISION STATEMENT
C     ( 9) 'DI' VARIABLE APPEARS IN A DIMENSION STATEMENT
C     (10)-'EQ' VARIABLE APPEARS IN AN EQUIVALENCE STATEMENT
C     (11) 'EX' FUNCTION NAME APPEARING IN AN EXTERNAL STATEMENT
C     (12) 'IN' VARIABLE APPEARS IN AN INTEGER STATEMENT
C     (13) 'LG' VARIABLE APPEARS IN A LOGICAL STATEMENT
C     (14) 'NM' VARIABLE APPEARS IN A NAMELIST STATEMENT
C     (15)-'PR' VARIABLE OR FORMAT NUMBER APPEARS IN A PRINT STATEMENT
C     (16)-'PU' VARIABLE OR FORMAT NUMBER APPEARS IN A PUNCH STATEMENT
C     (17)-'RD' VARIABLE OR FORMAT NUMBER APPEARS IN A READ STATEMENT
C     (18) 'RL' VARIABLE APPEARS IN A REAL STATEMENT
C     (19)-'WR' VARIABLE OR FORMAT NUMBER APPEARS IN A WRITE STATEMENT
C     (20)-'DO' VARIABLE OR STATEMENT NUMBER APPEARS IN A DO STATEMENT
C     (21) '..' VARIABLE APPEARS IN AN ILLEGAL SYNTAX STATEMENT
C
C     ARRAY  KLAST                  ARRAY  KSTOP
C        L    A    S    T              S    T    O    P
C
C     ARRAY KEND                    ARRAY KERR
C        E    N    D    =              E    R    R    =
C       (1)  (2)  (3)  (4)            (1)  (2)  (3)  (4)
C
C     TAPE N1 - LOGICAL 8 - SCRATCH - SUPER INDEX DATA
C               SET DCB TO - RECFM=FB - LRECL=112 - BLKSIZE=560
C               SPACE REQUIRED IS 10 TRACKS PRIMARY-10 TRACKS SECONDARY
C     TAPE N5 - LOGICAL 5 - INPUT TAPE
C     TAPE N6 - LOGICAL 6 - OUTPUT TAPE
C     TAPE N2 - LOGICAL 9 - SCRATCH - TABLE OF CONTENTS DATA
C               SET DCB THE SAME AS FOR TAPE N1
C               SPACE REQUIRED IS 5 TRACKS PRIMARY - 5 TRACKS SECONDARY
C
C     ARRAY KSTIJ - RECOGNIZED STATEMENTS - E.G. TEST STATEMENTS
C           KSTIJ IS STORED (I,J) FOR I=1 TO 11, J=1 TO KSTNUM
C           KSTIJ IS IN COMMON/SIGMA/ KSTNUM, KSTIJ(11,1)
C           KSTIJ(11,J)=N-THE NUMBER OF CHARACTERS IN THE TEST STATEMENT
C        J    N     STATEMENT   ITYPE  T*
C        1    6     ACCEPT        -    9
C        2    6     ASCENT        -   13
C        3    6     ASSIGN        2   15
C        4    9     BACKSPACE     1   16
C        5    9     BLOCKDATA     -   18
C        6    9     BUFFERIN(     1   17
C        7   10     BUFFEROUT(    1   17
C        8    4     CALL          3   21
C        9    6     COMMON        5   24
C       10   10     COMPLEX*16    6   28
C       11    8     CONTINUE      -    4
C       12    4     DATA          7   29
C       13    7     DECODE(       1   30
C       14    9     DIMENSION     8   32
C       15   10     DOUBLEPREC    9   33
C       16    6     DOUBLE        9   34
C       17    2     DO           20   35
C       18    7     ENCODE(       1   30
C       19    7     ENDFILE       1   16
C       20    3     END           -   40
C       21    5     ENTRY         3   20
C       22   10     EQUIVALENCE  10   42
C       23    8     EXTERNAL     11   43
C       24    5     FINISH        -   44
C       25    7     FORMAT(       -    4
C       26    7     FORTRAN       -   45
C       27    9     FREQUENCY     -    4
C       28    8     FUNCTION      3   18
C       29    5     GOTO(         1   46
C       30    4     GOTO          1   46
C       31   10     IFACCUMULA    1   49
C       32   10     IFQUOTIENT    1   49
C       33   10     IF(DIVIDEC    1   54
C       34   10     IF(ENDFILE    1   54
C       35   10     IF(SENSELI    1   54
C       36   10     IF(SENSESW    1   54
C       37    3     IF(           1   56
C       38    9     INTEGER*4    12   64
C       39    9     LOGICAL*4    13   65
C       40    7     MACHINE       -   13
C       41    8     NAMELIST     14   88
C       42    5     PAUSE         3   66
C       43    5     PRINT        15   67
C       44    7     PROGRAM       3   18
C       45    5     PUNCH        16   70
C       46   10     READINPUTT   17   71
C       47    8     READTAPE     17   75
C       48    5     READ(        17   78
C       49    4     READ         17   82
C       50    6     REAL*8       18   83
C       51    6     RETURN        3   66
C       52    6     REWIND        1   16
C       53    7     SEGMENT       -   18
C       54   10     SENSELIGHT    -    4
C       55    4     STOP          3   66
C       56   10     SUBROUTINE    3   18
C       57    4     TYPE          -   84
C       58   10     WRITEOUTPU   19   85
C       59    9     WRITETAPE    19   86
C       60    6     WRITE(       19   87
C       61    9     COMPLEX*8     6   28
C       62    7     COMPLEX       6   28
C       63    9     INTEGER*2    12   64
C       64    7     INTEGER      12   64
C       65    9     LOGICAL*1    13   65
C       66    7     LOGICAL      13   65
C       67    6     REAL*4       18   83
C       68    4     REAL         18   83
C       69   10     DEFINEFILE    -    4
C       70    5     FIND(         -    4
C       71    8     IMPLICIT      -    4
C     *   T = PROCESSING STATEMENT NUMBER IN MAIN PROGRAM
C
      BLOCK DATA
C
C     COPYRIGHT 1966, HARRY M. MURPHY, JR.
C     THIS BLOCK DATA CONTAINS ALL THE INDEX DATA STATEMENTS.
C
      COMMON/TAPES/N1,N2,N5,N6
      COMMON/ALPHA/ KBL,KABC(26),KDIG(10),KSPK(13)
      COMMON /BETA/ MXCH,MXLI,N15B,LINE,NPAGE,MXLINE
      COMMON /IOTA/ KEY(21)
      COMMON /KAPPA/ KAP(11)
      COMMON/TAU/ KTABLE(17)
      COMMON/PHI/ KCOPY(16)
      COMMON/LAMBDA/ KEND(4),KERR(4)
      COMMON/CHI/ KLEAR(8),NROUT,NRT,NKODE,IPAGE
      COMMON/OMEGA/ KLAST(5),KSTOP(5)
      COMMON/SIGMA/ KSTNUM,KST1 (11),KST2 (11),KST3 (11),KST4 (11),
     1 KST5 (11),KST6 (11),KST7 (11),KST8 (11),KST9 (11),KST10(11),
     2 KST11(11),KST12(11),KST13(11),KST14(11),KST15(11),KST16(11),
     3 KST17(11),KST18(11),KST19(11),KST20(11),KST21(11),KST22(11),
     4 KST23(11),KST24(11),KST25(11),KST26(11),KST27(11),KST28(11),
     5 KST29(11),KST30(11),KST31(11),KST32(11),KST33(11),KST34(11),
     6 KST35(11),KST36(11),KST37(11),KST38(11),KST39(11),KST40(11),
     7 KST41(11),KST42(11),KST43(11),KST44(11),KST45(11),KST46(11),
     8 KST47(11),KST48(11),KST49(11),KST50(11),KST51(11),KST52(11),
     9 KST53(11),KST54(11),KST55(11),KST56(11),KST57(11),KST58(11),
     A KST59(11),KST60(11),KST61(11),KST62(11),KST63(11),KST64(11),
     B KST65(11),KST66(11),KST67(11),KST68(11),KST69(11),KST70(11),
     C KST71(11)
      COMMON/THETA/ KFNUM,KFN1 (7),KFN2 (7),KFN3 (7),KFN4 (7),KFN5 (7),
     1  KFN6 (7),KFN7 (7),KFN8 (7),KFN9 (7),KFN10(7),KFN11(7),KFN12(7),
     2  KFN13(7),KFN14(7),KFN15(7),KFN16(7),KFN17(7),KFN18(7),KFN19(7),
     3  KFN20(7),KFN21(7),KFN22(7),KFN23(7),KFN24(7),KFN25(7),KFN26(7),
     4  KFN27(7),KFN28(7),KFN29(7),KFN30(7),KFN31(7),KFN32(7),KFN33(7),
     5  KFN34(7),KFN35(7),KFN36(7),KFN37(7),KFN38(7),KFN39(7),KFN40(7),
     6  KFN41(7),KFN42(7),KFN43(7),KFN44(7),KFN45(7),KFN46(7),KFN47(7),
     7  KFN48(7),KFN49(7),KFN50(7),KFN51(7),KFN52(7),KFN53(7),KFN54(7),
     8  KFN55(7),KFN56(7),KFN57(7),KFN58(7),KFN59(7),KFN60(7),KFN61(7),
     9  KFN62(7),KFN63(7),KFN64(7),KFN65(7),KFN66(7),KFN67(7),KFN68(7),
     A  KFN69(7),KFN70(7),KFN71(7),KFN72(7),KFN73(7),KFN74(7),KFN75(7),
     B  KFN76(7),KFN77(7),KFN78(7),KFN79(7),KFN80(7),KFN81(7),KFN82(7),
     C  KFN83(7),KFN84(7),KFN85(7),KFN86(7),KFN87(7),KFN88(7),KFN89(7),
     D  KFN90(7)
C
      DATA N1/8/, N2/9/, N5/5/, N6/6/
C
      DATA KBL,KDIG/1H ,1H0,1H1,1H2,1H3,1H4,1H5,1H6,1H7,1H8,1H9/
C
      DATA KABC/1HA,1HB,1HC,1HD,1HE,1HF,1HG,1HH,1HI,1HJ,1HK,1HL,1HM,
     1          1HN,1HO,1HP,1HQ,1HR,1HS,1HT,1HU,1HV,1HW,1HX,1HY,1HZ/
C
      DATA KSPK/1H=,1H,,1H(,1H/,1H),1H+,1H-,1H*,1H.,1H$,1H@,1H&,1H'/
C
      DATA KLEAR/8*1H /,NROUT/0/,NRT/0/,NKODE/0/,IPAGE/0/
C
      DATA MXCH/6/,MXLI/8191/,N15B/8192/,LINE/56/,NPAGE/0/,MXLINE/55/
C
      DATA KEY/2H  ,2H= ,2H* ,2HAG,2HCO,2HCX,2HDA,2HDI,2HDB,2HEQ,2HEX,
     1         2HIN,2HLG,2HNM,2HPR,2HPU,2HRD,2HRL,2HWR,2HDO,2H../
C
      DATA KCOPY/1HC,1HO,1HP,1HY,1HR,1HI,1HG,1HH,1HT,
     1           1H ,1HN,1HO,1HT,1HI,1HC,1HE/
      DATA KTABLE/1HT,1HA,1HB,1HL,1HE,1H ,1HO,1HF,1H ,
     1            1HC,1HO,1HN,1HT,1HE,1HN,1HT,1HS/
      DATA KAP/1HS,1HU,1HP,1HE,1HR,1H ,1HI,1HN,1HD,1HE,1HX/
C
      DATA KLAST/1HL,1HA,1HS,1HT,1H /, KSTOP/1HS,1HT,1HO,1HP,1H /
C
      DATA KEND/1HE,1HN,1HD,1H=/,  KERR/1HE,1HR,1HR,1H=/
C
      DATA KSTNUM/71/
      DATA KST1 /1HA,1HC,1HC,1HE,1HP,1HT,1H ,1H ,1H ,1H ,-6/
      DATA KST2 /1HA,1HS,1HC,1HE,1HN,1HT,1H ,1H ,1H ,1H ,-6/
      DATA KST3 /1HA,1HS,1HS,1HI,1HG,1HN,1H ,1H ,1H ,1H ,-6/
      DATA KST4 /1HB,1HA,1HC,1HK,1HS,1HP,1HA,1HC,1HE,1H , 9/
      DATA KST5 /1HB,1HL,1HO,1HC,1HK,1HD,1HA,1HT,1HA,1H , 9/
      DATA KST6 /1HB,1HU,1HF,1HF,1HE,1HR,1HI,1HN,1H(,1H , 9/
      DATA KST7 /1HB,1HU,1HF,1HF,1HE,1HR,1HO,1HU,1HT,1H(,10/
      DATA KST8 /1HC,1HA,1HL,1HL,1H ,1H ,1H ,1H ,1H ,1H ,-4/
      DATA KST9 /1HC,1HO,1HM,1HM,1HO,1HN,1H ,1H ,1H ,1H ,-6/
      DATA KST10/1HC,1HO,1HM,1HP,1HL,1HE,1HX,1H*,1H1,1H6,10/
      DATA KST11/1HC,1HO,1HN,1HT,1HI,1HN,1HU,1HE,1H ,1H ,8/
      DATA KST12/1HD,1HA,1HT,1HA,1H ,1H ,1H ,1H ,1H ,1H ,-4/
      DATA KST13/1HD,1HE,1HC,1HO,1HD,1HE,1H(,1H ,1H ,1H ,-7/
      DATA KST14/1HD,1HI,1HM,1HE,1HN,1HS,1HI,1HO,1HN,1H ,9/
      DATA KST15/1HD,1HO,1HU,1HB,1HL,1HE,1HP,1HR,1HE,1HC,10/
      DATA KST16/1HD,1HO,1HU,1HB,1HL,1HE,1H ,1H ,1H ,1H ,-6/
      DATA KST17/1HD,1HO,1H ,1H ,1H ,1H ,1H ,1H ,1H ,1H , 2/
      DATA KST18/1HE,1HN,1HC,1HO,1HD,1HE,1H(,1H ,1H ,1H ,-7/
      DATA KST19/1HE,1HN,1HD,1HF,1HI,1HL,1HE,1H ,1H ,1H ,7/
      DATA KST20/1HE,1HN,1HD,1H ,1H ,1H ,1H ,1H ,1H ,1H ,-3/
      DATA KST21/1HE,1HN,1HT,1HR,1HY,1H ,1H ,1H ,1H ,1H ,-5/
      DATA KST22/1HE,1HQ,1HU,1HI,1HV,1HA,1HL,1HE,1HN,1HC,10/
      DATA KST23/1HE,1HX,1HT,1HE,1HR,1HN,1HA,1HL,1H ,1H ,8/
      DATA KST24/1HF,1HI,1HN,1HI,1HS,1H ,1H ,1H ,1H ,1H ,-5/
      DATA KST25/1HF,1HO,1HR,1HM,1HA,1HT,1H(,1H ,1H ,1H ,-7/
      DATA KST26/1HF,1HO,1HR,1HT,1HR,1HA,1HN,1H ,1H ,1H ,7/
      DATA KST27/1HF,1HR,1HE,1HQ,1HU,1HE,1HN,1HC,1HY,1H ,9/
      DATA KST28/1HF,1HU,1HN,1HC,1HT,1HI,1HO,1HN,1H ,1H ,8/
      DATA KST29/1HG,1HO,1HT,1HO,1H(,1H ,1H ,1H ,1H ,1H ,-5/
      DATA KST30/1HG,1HO,1HT,1HO,1H ,1H ,1H ,1H ,1H ,1H ,-4/
      DATA KST31/1HI,1HF,1HA,1HC,1HC,1HU,1HM,1HU,1HL,1HA,10/
      DATA KST32/1HI,1HF,1HQ,1HU,1HO,1HT,1HI,1HE,1HN,1HT,10/
      DATA KST33/1HI,1HF,1H(,1HD,1HI,1HV,1HI,1HD,1HE,1HC,10/
      DATA KST34/1HI,1HF,1H(,1HE,1HN,1HD,1HF,1HI,1HL,1HE,10/
      DATA KST35/1HI,1HF,1H(,1HS,1HE,1HN,1HS,1HE,1HL,1HI,10/
      DATA KST36/1HI,1HF,1H(,1HS,1HE,1HN,1HS,1HE,1HS,1HW,10/
      DATA KST37/1HI,1HF,1H(,1H ,1H ,1H ,1H ,1H ,1H ,1H ,-3/
      DATA KST38/1HI,1HN,1HT,1HE,1HG,1HE,1HR,1H*,1H4,1H , 9/
      DATA KST39/1HL,1HO,1HG,1HI,1HC,1HA,1HL,1H*,1H4,1H , 9/
      DATA KST40/1HM,1HA,1HC,1HH,1HI,1HN,1HE,1H ,1H ,1H ,7/
      DATA KST41/1HN,1HA,1HM,1HE,1HL,1HI,1HS,1HT,1H ,1H ,8/
      DATA KST42/1HP,1HA,1HU,1HS,1HE,1H ,1H ,1H ,1H ,1H ,-5/
      DATA KST43/1HP,1HR,1HI,1HN,1HT,1H ,1H ,1H ,1H ,1H ,-5/
      DATA KST44/1HP,1HR,1HO,1HG,1HR,1HA,1HM,1H ,1H ,1H ,7/
      DATA KST45/1HP,1HU,1HN,1HC,1HH,1H ,1H ,1H ,1H ,1H ,-5/
      DATA KST46/1HR,1HE,1HA,1HD,1HI,1HN,1HP,1HU,1HT,1HT,10/
      DATA KST47/1HR,1HE,1HA,1HD,1HT,1HA,1HP,1HE,1H ,1H ,8/
      DATA KST48/1HR,1HE,1HA,1HD,1H(,1H ,1H ,1H ,1H ,1H ,-5/
      DATA KST49/1HR,1HE,1HA,1HD,1H ,1H ,1H ,1H ,1H ,1H ,-4/
      DATA KST50/1HR,1HE,1HA,1HL,1H*,1H8,1H ,1H ,1H ,1H , 6/
      DATA KST51/1HR,1HE,1HT,1HU,1HR,1HN,1H ,1H ,1H ,1H ,-6/
      DATA KST52/1HR,1HE,1HW,1HI,1HN,1HD,1H ,1H ,1H ,1H ,-6/
      DATA KST53/1HS,1HE,1HG,1HM,1HE,1HN,1HT,1H ,1H ,1H ,7/
      DATA KST54/1HS,1HE,1HN,1HS,1HE,1HL,1HI,1HG,1HH,1HT,10/
      DATA KST55/1HS,1HT,1HO,1HP,1H ,1H ,1H ,1H ,1H ,1H ,-4/
      DATA KST56/1HS,1HU,1HB,1HR,1HO,1HU,1HT,1HI,1HN,1HE,10/
      DATA KST57/1HT,1HY,1HP,1HE,1H ,1H ,1H ,1H ,1H ,1H ,-4/
      DATA KST58/1HW,1HR,1HI,1HT,1HE,1HO,1HU,1HT,1HP,1HU,10/
      DATA KST59/1HW,1HR,1HI,1HT,1HE,1HT,1HA,1HP,1HE,1H ,9/
      DATA KST60/1HW,1HR,1HI,1HT,1HE,1H(,1H ,1H ,1H ,1H ,-6/
      DATA KST61/1HC,1HO,1HM,1HP,1HL,1HE,1HX,1H*,1H8,1H , 9/
      DATA KST62/1HC,1HO,1HM,1HP,1HL,1HE,1HX,1H ,1H ,1H , 7/
      DATA KST63/1HI,1HN,1HT,1HE,1HG,1HE,1HR,1H*,1H2,1H , 9/
      DATA KST64/1HI,1HN,1HT,1HE,1HG,1HE,1HR,1H ,1H ,1H , 7/
      DATA KST65/1HL,1HO,1HG,1HI,1HC,1HA,1HL,1H*,1H1,1H , 9/
      DATA KST66/1HL,1HO,1HG,1HI,1HC,1HA,1HL,1H ,1H ,1H , 7/
      DATA KST67/1HR,1HE,1HA,1HL,1H*,1H4,1H ,1H ,1H ,1H , 6/
      DATA KST68/1HR,1HE,1HA,1HL,1H ,1H ,1H ,1H ,1H ,1H ,-4/
      DATA KST69/1HD,1HE,1HF,1HI,1HN,1HE,1HF,1HI,1HL,1HE,10/
      DATA KST70/1HF,1HI,1HN,1HD,1H(,1H ,1H ,1H ,1H ,1H ,-5/
      DATA KST71/1HI,1HM,1HP,1HL,1HI,1HC,1HI,1HT,1H ,1H , 8/
C
      DATA KFNUM/86/
      DATA KFN1 /1HE,1HX,1HP,1H ,1H ,1H ,  3/
      DATA KFN2 /1HD,1HE,1HX,1HP,1H ,1H ,  4/
      DATA KFN3 /1HC,1HE,1HX,1HP,1H ,1H ,  4/
      DATA KFN4 /1HC,1HD,1HE,1HX,1HP,1H ,  5/
      DATA KFN5 /1HA,1HL,1HO,1HG,1H1,1H0,  6/
      DATA KFN6 /1HA,1HL,1HO,1HG,1H ,1H ,  4/
      DATA KFN7 /1HD,1HL,1HO,1HG,1H1,1H0,  6/
      DATA KFN8 /1HD,1HL,1HO,1HG,1H ,1H ,  4/
      DATA KFN9 /1HC,1HL,1HO,1HG,1H ,1H ,  4/
      DATA KFN10/1HC,1HD,1HL,1HO,1HG,1H ,  5/
      DATA KFN11/1HA,1HR,1HS,1HI,1HN,1H ,  5/
      DATA KFN12/1HD,1HA,1HR,1HS,1HI,1HN,  6/
      DATA KFN13/1HA,1HR,1HC,1HO,1HS,1H ,  5/
      DATA KFN14/1HD,1HA,1HR,1HC,1HO,1HS,  6/
      DATA KFN15/1HA,1HT,1HA,1HN,1H2,1H ,  5/
      DATA KFN16/1HA,1HT,1HA,1HN,1H ,1H ,  4/
      DATA KFN17/1HD,1HA,1HT,1HA,1HN,1H2,  6/
      DATA KFN18/1HD,1HA,1HT,1HA,1HN,1H ,  5/
      DATA KFN19/1HS,1HI,1HN,1HH,1H ,1H ,  4/
      DATA KFN20/1HS,1HI,1HN,1H ,1H ,1H ,  3/
      DATA KFN21/1HD,1HS,1HI,1HN,1HH,1H ,  5/
      DATA KFN22/1HD,1HS,1HI,1HN,1H ,1H ,  4/
      DATA KFN23/1HC,1HS,1HI,1HN,1H ,1H ,  4/
      DATA KFN24/1HC,1HD,1HS,1HI,1HN,1H ,  5/
      DATA KFN25/1HC,1HO,1HS,1HH,1H ,1H ,  4/
      DATA KFN26/1HC,1HO,1HS,1H ,1H ,1H ,  3/
      DATA KFN27/1HD,1HC,1HO,1HS,1HH,1H ,  5/
      DATA KFN28/1HD,1HC,1HO,1HS,1H ,1H ,  4/
      DATA KFN29/1HC,1HC,1HO,1HS,1H ,1H ,  4/
      DATA KFN30/1HC,1HD,1HO,1HS,1H ,1H ,  4/
      DATA KFN31/1HT,1HA,1HN,1HH,1H ,1H ,  4/
      DATA KFN32/1HT,1HA,1HN,1H ,1H ,1H ,  3/
      DATA KFN33/1HD,1HT,1HA,1HN,1HH,1H ,  5/
      DATA KFN34/1HD,1HT,1HA,1HN,1H ,1H ,  4/
      DATA KFN35/1HC,1HO,1HT,1HA,1HN,1H ,  5/
      DATA KFN36/1HD,1HC,1HO,1HT,1HA,1HN,  6/
      DATA KFN37/1HS,1HQ,1HR,1HT,1H ,1H ,  4/
      DATA KFN38/1HD,1HS,1HQ,1HR,1HT,1H ,  5/
      DATA KFN39/1HC,1HS,1HQ,1HR,1HT,1H ,  5/
      DATA KFN40/1HC,1HD,1HS,1HQ,1HR,1HT,  6/
      DATA KFN41/1HE,1HR,1HF,1HC,1H ,1H ,  4/
      DATA KFN42/1HE,1HR,1HF,1H ,1H ,1H ,  3/
      DATA KFN43/1HD,1HE,1HR,1HF,1HC,1H ,  5/
      DATA KFN44/1HD,1HE,1HR,1HF,1H ,1H ,  4/
      DATA KFN45/1HG,1HA,1HM,1HM,1HA,1H ,  5/
      DATA KFN46/1HD,1HG,1HA,1HM,1HM,1HA,  6/
      DATA KFN47/1HA,1HL,1HG,1HA,1HM,1HA,  6/
      DATA KFN48/1HD,1HL,1HG,1HA,1HM,1HA,  6/
      DATA KFN49/1HM,1HO,1HD,1H ,1H ,1H ,  3/
      DATA KFN50/1HA,1HM,1HO,1HD,1H ,1H ,  4/
      DATA KFN51/1HD,1HM,1HO,1HD,1H ,1H ,  4/
      DATA KFN52/1HI,1HA,1HB,1HS,1H ,1H ,  4/
      DATA KFN53/1HA,1HB,1HS,1H ,1H ,1H ,  3/
      DATA KFN54/1HD,1HA,1HB,1HS,1H ,1H ,  4/
      DATA KFN55/1HC,1HA,1HB,1HS,1H ,1H ,  4/
      DATA KFN56/1HC,1HD,1HA,1HB,1HS,1H ,  5/
      DATA KFN57/1HI,1HN,1HT,1H ,1H ,1H ,  3/
      DATA KFN58/1HA,1HI,1HN,1HT,1H ,1H ,  4/
      DATA KFN59/1HI,1HD,1HI,1HN,1HT,1H ,  5/
      DATA KFN60/1HA,1HM,1HA,1HX,1H0,1H ,  5/
      DATA KFN61/1HA,1HM,1HA,1HX,1H1,1H ,  5/
      DATA KFN62/1HM,1HA,1HX,1H0,1H ,1H ,  4/
      DATA KFN63/1HM,1HA,1HX,1H1,1H ,1H ,  4/
      DATA KFN64/1HD,1HM,1HA,1HX,1H1,1H ,  5/
      DATA KFN65/1HA,1HM,1HI,1HN,1H0,1H ,  5/
      DATA KFN66/1HA,1HM,1HI,1HN,1H1,1H ,  5/
      DATA KFN67/1HM,1HI,1HN,1H0,1H ,1H ,  4/
      DATA KFN68/1HM,1HI,1HN,1H1,1H ,1H ,  4/
      DATA KFN69/1HD,1HM,1HI,1HN,1H1,1H ,  5/
      DATA KFN70/1HF,1HL,1HO,1HA,1HT,1H ,  5/
      DATA KFN71/1HD,1HF,1HL,1HO,1HA,1HT,  6/
      DATA KFN72/1HI,1HF,1HI,1HX,1H ,1H ,  4/
      DATA KFN73/1HH,1HF,1HI,1HX,1H ,1H ,  4/
      DATA KFN74/1HS,1HI,1HG,1HN,1H ,1H ,  4/
      DATA KFN75/1HI,1HS,1HI,1HG,1HN,1H ,  5/
      DATA KFN76/1HD,1HS,1HI,1HG,1HN,1H ,  5/
      DATA KFN77/1HD,1HI,1HM,1H ,1H ,1H ,  3/
      DATA KFN78/1HI,1HD,1HI,1HM,1H ,1H ,  4/
      DATA KFN79/1HS,1HN,1HG,1HL,1H ,1H ,  4/
      DATA KFN80/1HR,1HE,1HA,1HL,1H ,1H ,  4/
      DATA KFN81/1HA,1HI,1HM,1HA,1HG,1H ,  5/
      DATA KFN82/1HD,1HB,1HL,1HE,1H ,1H ,  4/
      DATA KFN83/1HC,1HM,1HP,1HL,1HX,1H ,  5/
      DATA KFN84/1HD,1HC,1HM,1HP,1HL,1HX,  6/
      DATA KFN85/1HC,1HO,1HN,1HJ,1HG,1H ,  5/
      DATA KFN86/1HD,1HC,1HO,1HN,1HJ,1HG,  6/
      END
      SUBROUTINE CENTOR
C     COPYRIGHT 1966, HARRY M. MURPHY, JR.
C
C     THIS ROUTINE CENTERS THE PAGE CAPTIONS.
C
      COMMON/DELTA/ JOB(66)
      COMMON/ALPHA/ KBL,KABC(26),KDIG(10),KSPK(13)
C
C     COMPRESS STATEMENT BY ELIMINATING MULTIPLE BLANKS.
C
      DO 2 I=1,66
      IF (JOB(I).NE.KBL) GO TO 3
2     CONTINUE
      RETURN
C
3     JOB(1)=JOB(I)
      J=1
      IB=I+1
      DO 4 I=IB,66
      IF (JOB(I).EQ.KBL.AND.JOB(I-1).EQ.KBL) GO TO 4
      J=J+1
      JOB(J)=JOB(I)
4     CONTINUE
C
      IB=J+1
      DO 5 I=IB,66
5     JOB(I)=KBL
C
C     CENTER HEADING.
C
      IB=(66-J)/2
6     I=J+IB
      JOB(I)=JOB(J)
      J=J-1
      IF(J.GT.0) GO TO 6
C
C     ELIMINATE REMAINING NON-BLANKS.
C
      IF(I.EQ.1) RETURN
      IB=I-1
      DO 8 I=1,IB
8     JOB(I)=KBL
      RETURN
      END
      SUBROUTINE CNTNTS
C     WRITTEN 1969, J.L. BALLINGER, THE BOEING COMPANY
C
C     THIS SUBROUTINE PRINTS A TABLE OF CONTENTS OF THE VARIOUS ROUTINES
C
      COMMON/TAPES/N1,N2,N5,N6
      COMMON/PSI/ LOCN,LIST(8191),LISTS(3,2500)
      COMMON/ZETA/ KBUFF(80),KODE,NEXT,NREC
      COMMON/CHI/ KLEAR(8),NROUT,NRT,NKODE,IPAGE
      COMMON/TAU/ KTABLE(17)
      COMMON/DELTA/ JOB(66)
      COMMON/ALPHA/ KBL,KABC(26),KDIG(10),KSPK(13)
      COMMON /BETA/ MXCH,MXLI,N15B,LINE,NPAGE,MXLINE
      DIMENSION KKODE (7845),KPAGE(7845)
      EQUIVALENCE (LIST(1),KKODE (1)),(LIST(7847),KPAGE(1))
      IF(NKODE.LT.2) RETURN
C
C     READ TABLE OF CONTENTS DATA
C
      REWIND N2
      READ(N2,1) (KKODE(I),KPAGE(I),I=1,NKODE)
    1 FORMAT(2I14)
C
C     EXTRACT SUPER INDEX PAGE
C
      JKODE=0
      K=NKODE
      DO 3 I=1,K
    2 IF(KKODE(I).GT.1) GO TO 3
      JKODE=JKODE+1
      KBUFF(JKODE)=KPAGE(I)
      KKODE(I)=KKODE(NKODE)
      KPAGE(I)=KPAGE(NKODE)
      KKODE(NKODE)=5
      NKODE=NKODE-1
      GO TO 2
    3 CONTINUE
C
C     SORT ON SUBROUTINE NAMES
C
      M=NKODE
    4 M=M/2
      IF(M.LE.0) GO TO 7
      K=NKODE-M
      DO 6 J=1,K
      I=J
    5 L=I+M
      IF(KKODE(I).LE.KKODE(L)) GO TO 6
      IK=KKODE(I)
      KKODE(I)=KKODE(L)
      KKODE(L)=IK
      IK=KPAGE(I)
      KPAGE(I)=KPAGE(L)
      KPAGE(L)=IK
      I=I-M
      IF(I.GT.0) GO TO 5
    6 CONTINUE
      GO TO 4
C
C     SETUP TABLE OF CONTENTS PAGE HEADING
C
    7 DO 8 I=1,17
      JOB(I)=KSPK(8)
      JOB(I+17)=KTABLE(I)
    8 JOB(I+34)=KSPK(8)
      JOB(17)=KBL
      JOB(35)=KBL
      CALL CENTOR
      CALL PAG(0)
C
C     PRINT THE TABLE OF CONTENTS
C
      DO 11 I=1,NKODE
      KODE=KKODE(I)
      CALL DECODE
      WRITE(N6,10) KLEAR, KPAGE(I)
   10 FORMAT(48X,8A1,5H.....,I4)
   11 CALL PAG(1)
      IF(JKODE.LT.1) RETURN
      DO 13 I=1,JKODE
      WRITE(N6,12) KBUFF(I)
   12 FORMAT(43X,18HSUPER INDEX  .....,I4)
   13 CALL PAG(1)
      RETURN
      END
      SUBROUTINE CPYRIT
      COMMON/PHI/ KCOPY(16)
      COMMON/ALPHA/ KBL,KABC(26),KDIG(10),KSPK(13)
      COMMON/DELTA/ JOB(66)
      COMMON/TAPES/N1,N2,N5,N6
C
C     SETUP COPYWRITE PAGE HEADING
C
      DO 111 I=1,16
      JOB(I)=KSPK(8)
      JOB(I+16)=KCOPY(I)
  111 JOB(I+32)=KSPK(8)
      JOB(16)=KBL
      JOB(33)=KBL
      CALL CENTOR
      CALL PAG(0)
C
C     PRINT THE COPYWRITE NOTICE
C
      WRITE(N6,1)
    1 FORMAT(1H0,9X,53HINDEX PROGRAM COPYRIGHT 1966, BY HARRY M. MURPHY,
     X JR./43X,28HAIR FORCE WEAPONS LABORATORY/43X,23HKIRKLAND AIR FORCE
     Y BASE/43X,10HNEW MEXICO)
C
C     PRINT THE DISCLAIMER
C
      WRITE(N6,2)
    2 FORMAT(1H0,9X,72H THIS RUN WAS PRODUCED BY A REVISION OF THE MAY 1
     X,1968 VERSION OF INDEX./5X,79HTHE REVISION CARRIES ALL RIGHTS RESE
     YRVED BY THE ORIGINATOR. NO CLAIM IS MADE BY/5X,70HTHE BOEING COMPA
     ZNY, OR THE REVISIONIST AS TO THE ORGIN OF THE PROGRAM.)
C
C     PRINT THE USER LICENCE
C
      WRITE(N6,3)
    3 FORMAT(1H0,9X,64HTHE ORIGINATOR RELEASED THE PROGRAM UNDER THE FOL
     1LOWING LICENSE./5X,94HA GENERAL LICENSE IS HEREBY GRANTED TO ALL A
     2GENCIES OF THE UNITED STATES GOVERMENT, AND TO ALL/5X,97HCONTRACTO
     3RS TO THE UNITED STATES GOVERNMENT, TO COPY AND TO MAKE FREE USE O
     4F THIS PROGRAM WITHOUT/5X,81HPAYMENT OF ANY FEE, PROVIDING THAT AL
     5L SUCH COPIES CONTAIN THIS COPYRIGHT NOTICE.)
C
C     PRINT THE REVISIONS NOTICE
C
      WRITE(N6,4)
    4 FORMAT(1H0,9X,22HTHE REVISIONS INCLUDE./5X,62H1. THE NECESSARY MOD
     1IFICATIONS TO PROCESS IBM S/360 FORTRAN 4./5X,60H2. ADDED THE GENE
     2RATION AND OUTPUT OF THE TABLE OF CONTENTS./5X,41H3. ADDED THE FLA
     3G OF UNDEFINED VARIABLES./5X,25H4. OUTPUT OF THIS NOTICE.)
      WRITE(N6,5)
    5 FORMAT(1H0,9X,92HREVISED OCTOBER 1969 BY J. L. BALLINGER, BOEING C
     XOMPUTER SERVICES, INC., HUNTSVILLE ALABAMA.)
      RETURN
      END
      SUBROUTINE DECODE
C     COPYRIGHT 1966, HARRY M. MURPHY, JR.
C
C     THIS SUBROUTINE TRANSLATES THE CODED SYMBOL IN KODE INTO THE
C     ARRAY, KLEAR.
C
      COMMON/ZETA/ KBUFF(80),KODE,NEXT,NREC
      COMMON/CHI/ KLEAR(8),NROUT,NRT,NKODE,IPAGE
      COMMON/ALPHA/ KBL,KABC(26),KDIG(10),KSPK(13)
      COMMON /BETA/ MXCH,MXLI,N15B,LINE,NPAGE,MXLINE
C
      DIMENSION KSYM(37)
      EQUIVALENCE (KBL,KSYM(1))
C
      KA=KODE
      L=MXCH
2     KB=KA/37
      I=KA+1-KB*37
      KLEAR(L)=KSYM(I)
      KA=KB
      L=L-1
      IF(L.GT.0) GO TO 2
      L=0
      DO 4 I=1,MXCH
      IF (KLEAR(I).EQ.KBL) GO TO 4
      L=L+1
      KLEAR(L)=KLEAR(I)
4     CONTINUE
    5 L=L+1
      IF(L.GT.8) RETURN
      KLEAR(L)=KBL
      GO TO 5
      END
      SUBROUTINE ERROR
C     COPYRIGHT 1966, HARRY M. MURPHY, JR.
      COMMON/TAPES/N1,N2,N5,N6
      COMMON/ETA/KMAX,KOL,KRSX,KLSX
      COMMON/RHO/ KARD(1326)
      INTEGER*2 M(2)
      DATA M /1HI,1HS/
C
      I=1
      IF(KOL.LT.0) I=2
      KOL=IABS(KOL)
      J=KOL-8
      WRITE(N6,2) M(I),(KARD(K),K=J,KOL)
      CALL PAG (1)
      RETURN
C
    2 FORMAT(10X,4H****,A1,24(1H*),25H S Y N T A X   E R R O R ,24(1H*),
     X    12X,9A1)
      END
C     PROGRAM INDEX(INPUT,OUTPUT,OO1,TAPE1=OO1,TAPE5=INPUT,TAPE6=OUTPUT)
C     COPYRIGHT 1966, HARRY M. MURPHY, JR.
C     NOTE - A GENERAL LICENSE IS HEREBY GRANTED TO ALL AGENCIES OF THE
C     UNITED STATES GOVERNMENT AND TO ALL CONTRACTORS TO THE UNITED
C     STATES GOVERNMENT TO COPY AND TO MAKE FREE USE OF THIS PROGRAM
C     WITHOUT PAYMENT OF ANY FEE, PROVIDING THAT ALL SUCH COPIES
C     CONTAIN THIS COPYRIGHT NOTICE.
C
C     I N D E X   -   A PROGRAM FOR GENERATING A CROSS-REFERENCE
C     DICTIONARY OF ALL STATEMENT NUMBERS AND ALL SYMBOLS IN FORTRAN
C     SOURCE PROGRAMS.
C
C     THIS PROGRAM IS A REVISION OF THE ABOVE REFERENCED PROGRAM AND
C     CARRIES ALL THE RIGHTS RESERVED BY THE ORIGINATOR.NO CLAIM IS
C     MADE BY THE BOEING COMPANY OR THE REVISIONIST AS TO THE
C     ORIGINATION OF THE PROGRAM
C     MODIFIED BY J.W. DANIEL, THE BOEING COMPANY, HUNTSVILLE ALABAMA
C     MODIFIED BY J.L. BALLINGER, THE BOEING COMPANY, HUNTSVILLE ALABAMA
C
C                          26 OCTOBER 1966
C     THIS IS THE 1 MAY 1968 VERSION OF INDEX WHICH USES A CODING
C     ALGORITHM FOR KODE BY DOUG GATCHELL OF THE UNIVERSITY OF N.M. (HM)
C               *****   A S A   F O R T R A N   *****
C
      COMMON/INDEX/ DTLINE
      COMMON/ZETA/ KBUFF(80),KODE,NEXT,NREC
      COMMON/CHI/ KLEAR(8),NROUT,NRT,NKODE,IPAGE
      COMMON/ETA/KMAX,KOL,KRSX,KLSX
C     KMAX = NUMBER OF CHARACTERS IN KARD (FROM INPUT ROUTINE)
      COMMON/RHO/ KARD(1326)
      COMMON/GAMMA/ ITYPE,MAXA,MINA,NSYM
      COMMON/ALPHA/ KBL,KABC(26),KDIG(10),KSPK(13)
      COMMON /BETA/ MXCH,MXLI,N15B,LINE,NPAGE,MXLINE
      COMMON/LAMBDA/ KEND(4),KERR(4)
      COMMON/SIGMA/ KSTNUM,KSTIJ(11,71)
      COMMON/TAPES/N1,N2,N5,N6
C
C     FOR MXCH=6, MINA=69343957, MAXA=1872286818
C
      MINA=37**(MXCH-1)
      MAXA=27*MINA-1
      REWIND N1
      REWIND N2
    3 NEXT = 1
      NSYM=0
      NREC=0
C
C     GET FORTRAN STATEMENT.
C
4     CALL INPUT
      IF (KODE.EQ.0) GO TO 5

      ITYPE=3
      CALL UPDATE
C
C     IDENTIFY FORTRAN STATEMENT BY TYPE.
C
5     KOL=1
    6 DO 8 J=1,KSTNUM
      NIST = IABS(KSTIJ(11,J))
      DO 7 I=1,NIST
      LAST=KOL+I
      IF (KARD(LAST).NE.KSTIJ(I,J)) GO TO 8
7     CONTINUE
C
C     CHECK FOR ARITHMETIC STATEMENT
C
      IF(KSTIJ(11,J).GT.0) GO TO 801
      LL = LAST+1
      IF(LL.GE.KMAX) GO TO 801
      LEVEL = 0
      IF(KARD(LAST).EQ.KSPK(3)) LEVEL = 1
      NPAR=0
      DO 701 I=LL,KMAX
      IF(KARD(I).EQ.KSPK(1).AND.LEVEL.EQ.0) GO TO 702
      IF(KARD(I).EQ.KSPK(3)) LEVEL = LEVEL+1
      IF(KARD(I).EQ.KSPK(5)) LEVEL = LEVEL-1
      NPAR=MAX0(NPAR,LEVEL)
      IF((LEVEL.NE.0).OR.(NPAR.EQ.0)) GO TO 701
      IF(KARD(I+1).NE.KSPK(1)) GO TO 801
  701 CONTINUE
      GO TO 801
  702 IF(J.NE.37) GO TO 9
      IF(KARD(I-1).EQ.KSPK(5)) GO TO 9
  801 CONTINUE
C
C     GO TO FORTRAN STATEMENT PROCESSING BY TYPE.
C
      GO TO( 9,13,15,16,18,17,17,21,24,28, 4,29,30,32,33,34,35,30,16,40,
     1   20,42,43,44, 4,45, 4,18,46,46,49,49,54,54,54,54,56,64,65,13,88,
     2   66,67,18,70,71,75,78,82,83,66,16,18, 4,66,18,84,85,86,87,28,28,
     3   64,64,65,65,83,83, 4, 4, 4),J
C
8     CONTINUE
C
C     NOT IN STATEMENT LIST.  ASSUME ARITHMETIC AND LOOK FOR =.
C
9     ITYPE=2
      DO 10 I=KOL,KMAX
      IF (KARD(I).EQ.KSPK(1)) GO TO 11
10    CONTINUE
      CALL ERROR
      ITYPE=21
11    CALL SYMBOL
      IF(KODE.LE.0) GO TO 4
      IF (KODE.LT.MINA.OR.KODE.GT.MAXA) GO TO 11
      CALL UPDATE
      ITYPE=1
      GO TO 11
C
C           **********************************************
C           *  FORTRAN STATEMENT PROCESSING STARTS HERE  *
C           **********************************************
C
C     ASCENT, MACHINE, ETC.
C
13    CALL INPUT
      DO 14 I=1,3
      IF (KARD(I+1).NE.KSTIJ(I,20)) GO TO 13
14    CONTINUE
      IF (KMAX.EQ.4) GO TO 3
      GO TO 13
C
C     ASSIGN 12345 TO N.
C
15    KOL=LAST
      CALL SYMBOL
      IF (KODE.GE.MINA.AND.KODE.LE.MAXA) CALL ERROR
      ITYPE=1
      CALL UPDATE
      KOL=KOL+1
      CALL SYMBOL
      IF (KODE.LT.MINA.OR.KODE.GT.MAXA) CALL ERROR
      ITYPE=2
      CALL UPDATE
      GO TO 4
C
C     BACKSPACE, ENDFILE, REWIND, ETC.
C
16    KOL=LAST
      ITYPE=1
      CALL SYMBOL
      IF (KODE.GE.MINA.AND.KODE.LE.MAXA) CALL UPDATE
      GO TO 4
C
C     BUFFER IN   ///   BUFFER OUT.
C
17    ITYPE=1
      GO TO 25
C
C     BLOCK DATA, FUNCTION, PROGRAM, SUBROUTINE.
C
18    IF (NREC.EQ.1.OR.NSYM.LT.2) GO TO 19
      WRITE (N6,89)
      CALL PAG (3)
      CALL SORT
      CALL OUTPUT
      NREC=1
      NSYM=0
      NEXT = 1
   19 IF (J.NE.5) GO TO 21
      KODE=161382568
C     KODE = 161382568 = SYMBOLIC NAME 'BLDATA' FOR BLOCK DATA ROUTINE
      ITYPE=3
      CALL UPDATE
      GO TO 4
C
C     CALL XYZ (ARG LIST).
C     PROCESS - FUNCTION, ENTRY, SUBROUTINE, AND PROGRAM STATEMENTS
C
   20 KOL=LAST
      CALL SYMBOL
      IF(KODE.LT.MINA.OR.KODE.GT.MAXA) GO TO 21
      I=-IPAGE
      WRITE(N2,1) KODE,I
    1 FORMAT(2I14)
      NKODE=NKODE+1
21    KOL=LAST
      ITYPE=3
      CALL SYMBOL
      IF (KODE.LT.MINA.OR.KODE.GT.MAXA) CALL ERROR
      CALL UPDATE
      ITYPE=4
   22 CALL SYMBOL
      IF(KODE.LE.0) GO TO 4
      IF(KODE.GE.MINA.AND.KODE.LE.MAXA.OR.KLSX.EQ.KSPK(12)) CALL UPDATE
      GO TO 22
C
C     COMMON STATEMENT.
C
   24 ITYPE=3
      KOL=LAST
      IF(KARD(LAST+1).NE.KSPK(4)) GO TO 241
      CALL SYMBOL
      IF(KODE.LT.MINA.OR.KODE.GT.MAXA) CALL ERROR
      CALL UPDATE
  241 ITYPE=5
      GO TO 26
C
C     PROCESS REMAINDER OF THE STATEMENT
C
25    KOL=LAST
26    CALL SYMBOL
      IF(KODE.LE.0) GO TO 4
      IF(KODE.GE.MINA.AND.KODE.LE.MAXA) CALL UPDATE
      GO TO 26
C
C     COMPLEX STATEMENT.
C
28    ITYPE=6
      IF(J.EQ.62) GO TO 90
      GO TO 93
C
C     DATA STATEMENT.
C
29    ITYPE=7
      GO TO 93
C
C     DECODE, ENCODE.
C
30    KOL=LAST
      ITYPE=1
      CALL SYMBOL
      IF(KODE.LE.0) GO TO 4
      CALL SYMBOL
      CALL UPDATE
      GO TO 26
C
C     DIMENSION STATEMENT.
C
32    ITYPE=8
      GO TO 25
C
C     DOUBLE PRECISION STATEMENT.
C
   33 LAST = LAST+5
      ITYPE=9
      GO TO 90
C
C     DOUBLE STATEMENT.
C
34    ITYPE=9
      GO TO 25
C
C     DO STATEMENT.
C
35    DO 36 I=LAST,KMAX
      IF (KARD(I).EQ.KSPK(1)) GO TO 37
      IF (KARD(I).EQ.KSPK(3)) GO TO 9
36    CONTINUE
      GO TO 92
37    IB=I
      DO 38 I=IB,KMAX
      IF (KARD(I).EQ.KSPK(2)) GO TO 39
38    CONTINUE
      GO TO 11
39    KOL=LAST
      ITYPE=20
      IF (KARD(I).EQ.KSPK(3)) GO TO 11
      CALL SYMBOL
      IF (KODE.GE.MINA.AND.KODE.LE.MAXA) CALL ERROR
      CALL UPDATE
      KOL=KOL-1
      GO TO 26
C
C              *****************************************
C              *            END STATEMENT              *
C              *      EXECUTE SORT AND PRINT INDEX     *
C              *****************************************
C
40    IF (KMAX.GT.LAST) GO TO 9
      CALL SORT
      CALL OUTPUT
      GO TO 3
C
C     EQUIVALENCE STATEMENT.
C
42    ITYPE=10
      KOL=LAST+1
      GO TO 26
C
C     EXTERNAL STATEMENT.
C
43    ITYPE=11
      GO TO 25
C
C     FINISH STATEMENT
C
44    IF (KMAX.GT.LAST) GO TO 9
      IF (NREC.EQ.1.OR.NSYM.LT.2) STOP
      CALL SORT
      CALL OUTPUT
      STOP
C
C     FORTRAN OR TYPE STATEMENT.
C
45    KOL=LAST
      GO TO 6
C
C     GO TO (1,2,3,4,5), N   ///   GO TO 1   ///   GO TO N   ///   ETC.
C
46    KOL=LAST
      ITYPE=1
47    CALL SYMBOL
      IF(KODE.LE.0) GO TO 4
      CALL UPDATE
      GO TO 47
C
C     IF ACCUMULATOR OVERFLOW STATEMENT.
C
49    DO 50 I=LAST,KMAX
      IF (KARD(I).EQ.KABC(23)) GO TO 51
50    CONTINUE
      GO TO 92
51    KOL=I
      ITYPE=1
52    CALL SYMBOL
      IF(KODE.LE.0) GO TO 4
      IF (KODE.GE.MINA.AND.KODE.LE.MAXA) CALL ERROR
      CALL UPDATE
      GO TO 52
C
C     IF (DIVIDE CHECK) /// IF (END FILE) /// IF (SENSE LIGHT).
C     IF (SENSE SWITCH) 1,2
C
54    DO 55 I=LAST,KMAX
      IF (KARD(I).EQ.KSPK(5)) GO TO 51
55    CONTINUE
      GO TO 92
C
C     IF (ARITH) 1,2,3   ///   IF (LOGICAL) STATEMENT.
C
C     LOOK FOR PARENTHESIS COUNT OF ZERO.
C
56    NPAR=0
      DO 58 I=LAST,KMAX
      IF (KARD(I).NE.KSPK(3)) GO TO 57
      NPAR=NPAR+1
      GO TO 58
57    IF (KARD(I).NE.KSPK(5)) GO TO 58
      NPAR=NPAR-1
      IF (NPAR) 59,59,58
58    CONTINUE
      GO TO 92
C
C     SCAN SYMBOLS WITHIN PARENTHESIS.
C
59    J=KMAX
      IB=I
      KMAX=IB
      ITYPE=1
      KOL=LAST
60    CALL SYMBOL
      IF(KODE.LE.0) GO TO 62
      IF(KODE.GE.MINA.AND.KODE.LE.MAXA) CALL UPDATE
      GO TO 60
62    KOL=IB
      KMAX=J
C
C     LOOK FOR DIGIT IMMEDIATELY AFTER PARENTHESIS.  IF ONE IS NOT
C     FOUND, THE IF STATEMENT IS PROBABLY LOGICAL.
C
      DO 63 I=1,10
      IF (KARD(KOL+1).EQ.KDIG(I)) GO TO 52
63    CONTINUE
      GO TO 6
C
C     INTEGER STATEMENT.
C
64    ITYPE=12
      IF(J.EQ.64) GO TO 90
      GO TO 93
C
C     LOGICAL STATEMENT.
C
65    ITYPE=13
      IF(J.EQ.66) GO TO 90
      GO TO 93
C
C     PAUSE, STOP, RETURN STATEMENT.
C
   66 ITYPE=3
      I = KMAX
      KMAX = LAST
      CALL SYMBOL
      CALL UPDATE
      IF(I.EQ.KMAX) GO TO 4
      KMAX = I
      GO TO 16
C
C     PRINT STATEMENT.
C
67    ITYPE=15
68    KOL=LAST
      CALL SYMBOL
      IF(KODE.LE.0) GO TO 4
      CALL UPDATE
      GO TO 26
C
C     PUNCH STATEMENT.
C
70    ITYPE=16
      GO TO 68
C
C     READ INPUT TAPE N, M, LIST.
C
71    ITYPE=17
      KOL=LAST+3
72    CALL SYMBOL
      IF(KODE.LE.0) GO TO 4
      IF(KODE.GE.MINA.AND.KODE.LE.MAXA) CALL UPDATE
      CALL SYMBOL
      IF(KODE.LE.0) GO TO 4
      CALL UPDATE
      GO TO 26
C
C     READ TAPE N, LIST
C
75    ITYPE=17
76    KOL=LAST
      CALL SYMBOL
      IF(KODE.LE.0) GO TO 4
      IF(KODE.GE.MINA.AND.KODE.LE.MAXA) CALL UPDATE
      GO TO 26
C
C     READ (N) LIST   ///   READ (N,M) LIST
C
78    ITYPE=17
79    KOL=LAST
      CALL SYMBOL
      IF(KODE.LE.0) GO TO 4
      IF (KODE.GE.MINA.AND.KODE.LE.MAXA) CALL UPDATE
C
C     LOOK FOR END= OR ERR= OR BOTH IN THE READ STATEMENT
C
   81 IF(KRSX.EQ.KSPK(5)) GO TO 26
      DO 811 I=1,4
      IF(KARD(KOL+I).EQ.KEND(I)) GO TO 811
      IF(KARD(KOL+I).NE.KERR(I)) GO TO 822
  811 CONTINUE
      KOL=KOL+4
      KARD(KOL)=KSPK(2)
  822 CALL SYMBOL
      IF(KODE.LE.0) GO TO 4
      CALL UPDATE
      GO TO 81
C
C     READ N, LIST
C
82    ITYPE=17
      GO TO 68
C
C     REAL STATEMENT.
C
83    ITYPE=18
      IF(J.EQ.68) GO TO 90
      GO TO 93
C
C     TYPE STATEMENT.
C
84    KOL=LAST
      GO TO 6
C
C     WRITE OUTPUT TAPE N, M, LIST
C
85    ITYPE=19
      KOL=LAST+5
      GO TO 72
C
C     WRITE TAPE N, LIST.
C
86    ITYPE=19
      GO TO 76
C
C     WRITE(N) LIST      ///      WRITE(N,M)LIST
C
87    ITYPE=19
      GO TO 79
C
C     NAMELIST STATEMENT.
C
88    ITYPE=14
      GO TO 25
C
89    FORMAT (1H0,9X,5H*****,5X,4(6H******),5X,21HMISSING END STATEMENT,
     15X,4(6H******)/1X)
C
C     TEST FOR TYPE FUNCTION STATEMENT
C
   90 NIST = KSTIJ(11,28)
      DO 91 I=1,NIST
      IF(KARD(LAST+I).NE.KSTIJ(I,28)) GO TO 93
   91 CONTINUE
      LAST = LAST+NIST
      GO TO 21
C
C     STANDARD ERROR CALL INGORE REST OF STATEMENT
C
   92 CALL ERROR
      GO TO 4
C
C     DELETE DATA INITIALIZATION FIELDS
C
   93 KOL=LAST-1
      NPAR=0
      DO 95 I=LAST,KMAX
      IF(KARD(I).NE.KSPK(4)) GO TO 94
      NPAR=MOD(NPAR+1,2)
      GO TO 95
   94 IF(NPAR.NE.0) GO TO 95
      KOL=KOL+1
      KARD(KOL)=KARD(I)
   95 CONTINUE
      KMAX=KOL
      GO TO 25
      END
      SUBROUTINE INPUT
C     COPYRIGHT 1966, HARRY M. MURPHY, JR.
C
C     THIS SUBROUTINE READS ALL INPUT CARDS AND CHECKS THEM FOR COMMENTS
C     AND CONTROL STATEMENTS.  IF NEITHER, THE STATEMENTS ARE SCANNED
C     FOR HOLLERITH FIELDS, SUCH FIELDS ARE BLANKED OUT, AND THE
C     REMAINDER OF THE STATEMENT IS PACKED IN THE SUPER-CARD ARRAY,
C     KARD.  KMAX IS THEN SET TO THE NUMBER OF COLUMNS IN KARD THAT
C     CONTAIN VALID DATA.
C
      COMMON/ZETA/ KBUFF(80),KODE,NEXT,NREC
C
C     NREC = INDEX ASSIGNED STATEMENT NUMBER(ISN)
C
      COMMON/ETA/KMAX,KOL,KRSX,KLSX
      COMMON/CHI/ KLEAR(8),NROUT,NRT,NKODE,IPAGE
      COMMON/DELTA/ JOB(66)
      COMMON/RHO/ KARD(1326)
      COMMON/ALPHA/ KBL,KABC(26),KDIG(10),KSPK(13)
      COMMON /BETA/ MXCH,MXLI,N15B,LINE,NPAGE,MXLINE
      COMMON/OMEGA/ KLAST(5),KSTOP(5)
      COMMON/TAPES/N1,N2,N5,N6
      EQUIVALENCE (KBUFF(1),KB1), (KBUFF(6),KB6)
C
C     A    B    C    D    E    F    G    H    I    J    K    L    M
C     1    2    3    4    5    6    7    8    9    10   11   12   13
C
C     N    O    P    Q    R    S    T    U    V    W    X    Y    Z
C     14   15   16   17   18   19   20   21   22   23   24   25   26
C
C     =    ,    (    /    )    +    -    *    .    $   8/4   &
C     1    2    3    4    5    6    7    8    9    10   11   12
C
C     CHECK FOR FIRST CALL.
C
      IJK=0
      IF(NPAGE) 2,2,4
C
C     THIS IS FIRST CALL.  LOAD EMPTY BUFFER, KBUFF.
C
2     READ(N5,42,END=51) KBUFF
      CALL VAXFIX(KBUFF)
      DO 3 I=1,72
      IF (KBUFF(I).NE.KBL) GO TO 4
3     CONTINUE
      GO TO 2
    4 IF(NREC.GT.0) GO TO 8
C
C     SET UP PAGE CAPTION.
C
      IF(KB1.EQ.KSPK(8)) GO TO 37
      DO 6 I=1,66
6     JOB(I)=KBUFF(I+6)
      CALL CENTOR
      CALL PAG (0)
      IPAGE=NPAGE
      IF(IJK.LE.0) GO TO 8
      WRITE(N6,43) (KARD(I),I=1,IJK)
      CALL PAG(IJK/80)
      GO TO 8
C
C     COPY THROUGH COMMENTS, LOOKING FOR FORTRAN STATEMENTS.
C
7     WRITE (N6,43) KBUFF
      CALL PAG (1)
      READ(N5,42,END=51) KBUFF
      CALL VAXFIX(KBUFF)
8     IF (KB1.EQ.KABC(3).OR.KB1.EQ.KSPK(10)) GO TO 7
      IF (KB1.EQ.KSPK(8)) GO TO 37
C
C     HAVE FORTRAN STATEMENT.  START PACKING KARD.
C
      NREC=NREC+1
      WRITE (N6,44) NREC,KBUFF
      CALL PAG (1)
      DO 9 I=1,72
9     KARD(I)=KBUFF(I)
      K7=7
      K72=72
C
C     LOOK FOR CONTINUATION CARDS AND PACK IN KARD.
C
      DO 13 J=2,20
10    READ(N5,42,END=51) KBUFF
      CALL VAXFIX(KBUFF)
      DO 11 I=1,72
      IF (KBUFF(I).NE.KBL) GO TO 12
11    CONTINUE
      WRITE (N6,45)
      CALL PAG (1)
      GO TO 10
C
   12 IF(KB1.EQ.KABC(3).OR.KB1.EQ.KSPK(8).OR.KB1.EQ.KSPK(10).OR.
     X   KB6.EQ.KBL.OR.KB6.EQ.KDIG(1)) GO TO 16
      WRITE (N6,43) KBUFF
      CALL PAG (1)
      K7=K7+66
      K72=K72+66
      L=6
      DO 13 I=K7,K72
      L=L+1
13    KARD(I)=KBUFF(L)
C
C     NINETEEN CONTINUATION CARDS.  LOAD EMPTY BUFFER.
C
14    READ(N5,42,END=51) KBUFF
      CALL VAXFIX(KBUFF)
      DO 15 I=1,72
      IF (KBUFF(I).NE.KBL) GO TO 16
15    CONTINUE
      WRITE (N6,45)
      CALL PAG (1)
      GO TO 14
C
C     GET STATEMENT NUMBER, IF ANY.
C
16    KODE=0
      DO 19 I=1,5
      IF (KARD(I).EQ.KBL) GO TO 19
      DO 17 J=1,10
      IF (KARD(I).EQ.KDIG(J)) GO TO 18
17    CONTINUE
      RETURN
18    IF (J.EQ.1.AND.KODE.EQ.0) GO TO 19
      KODE=KODE*37+J+26
19    CONTINUE
C
C     ELIMINATE ANY HOLLERITH FIELDS.
C
      IB=8
20    DO 21 I=IB,K72
      IF (KARD(I).EQ.KABC(8)) GO TO 22
21    CONTINUE
      GO TO 35
C
C     H FOUND AT KARD(I).  LOOK FOR PRECEEDING DIGITS.
C
22    MAX=I-IB+1
      NH=0
      L=I
      DO 25 J=1,MAX
      L=L-1
      IF (KARD(L).EQ.KBL) GO TO 25
      DO 23 IS=1,10
      IF (KARD(L).EQ.KDIG(IS)) GO TO 24
23    CONTINUE
      IF (NH) 34,34,26
24    NH=NH+1
25    CONTINUE
      GO TO 34
C
C     NOT DIGITS.  LOOK FOR SPECIAL CHARACTERS = , ( / ) + - * .
C
26    DO 27 IS=1,9
      IF (KARD(L).EQ.KSPK(IS)) GO TO 28
27    CONTINUE
      GO TO 34
C
C     ASSEMBLE HOLLERITH FIELD WIDTH.
C
28    NH=0
      LD1=L+1
      LD2=I-1
      DO 31 L=LD1,LD2
      IF (KARD(L).EQ.KBL) GO TO 31
      DO 29 IS=1,10
      IF (KARD(L).EQ.KDIG(IS)) GO TO 30
29    CONTINUE
      GO TO 31
30    NH=NH*10+IS-1
31    CONTINUE
C
C     TEST FOR HOLLERITH FIELD WIDTH OF ZERO.
C
      IF(NH.LE.0) GO TO 34
C
C     BLANK OUT ENTIRE HOLLERITH FIELD, INCLUDING H AND DIGITS.
C
      LD2=I+NH
      IF (LD2.GT.1326) LD2=1326
      DO 33 I=LD1,LD2
33    KARD(I)=KBL
34    IB=I+1
      IF (IB.LT.K72) GO TO 20
C
C     BLANK OUT HOLLERITH FIELDS THAT ARE ENCLOSED BY APOSTOPHIES (')
C
   35 LD2=0
      DO 353 I=7,K72
      IF(KARD(I).EQ.KSPK(13)) LD2=LD2+1
  353 CONTINUE
      IF(MOD(LD2,2).NE.0) GO TO 354
      LD2=0
      DO 352 I=7,K72
      IF(KARD(I).NE.KSPK(13)) GO TO 351

      LD2=MOD(LD2+1,2)
      KARD(I)=KDIG(1)
  351 IF(LD2.NE.0) KARD(I)=KBL
  352 CONTINUE
C
C     SQUEEZE OUT ALL BLANKS.  PUT BLANK IN KARD(1), AND START SQUEEZE
C     IN KARD(2).
C
  354 KMAX=1
      KARD(1)=KBL
      DO 36 I=7,K72
      IF (KARD(I).EQ.KBL) GO TO 36
      KMAX=KMAX+1
      KARD(KMAX)=KARD(I)
36    CONTINUE
      RETURN
C
C     LOOK FOR *LAST OR *STOP CONTROL CARDS.
C
37    I=1
      DO 38 J=2,72
      IF (KBUFF(J).EQ.KBL) GO TO 38
      IF (KBUFF(J).NE.KLAST(I)) GO TO 39
      I=I+1
38    CONTINUE
      IF(I.EQ.5) GO TO 41
      GO TO 401
39    I=1
      DO 40 J=2,72
      IF (KBUFF(J).EQ.KBL) GO TO 40
      IF(KBUFF(J).NE.KSTOP(I)) GO TO 401
      I=I+1
40    CONTINUE
      IF(I.EQ.5) GO TO 41
  401 IF(NREC.NE.0) GO TO 7
C
C     SAVE CONTENTS OF * CARD FOR LATTER PRINTING
C
      IF(IJK.GE.1280) GO TO 2
      DO 402 I=1,80
      IJK=IJK+1
  402 KARD(IJK)=KBUFF(I)
      GO TO 2
C
C                       **********************
C                       *  INDEX EXITS HERE  *
C                       **********************
   41 CALL SUPER
      CALL CNTNTS
      CALL CPYRIT
      STOP
C
C     END OF FILE ENCOUNTERED IN INPUT STREAM
C         SETUP  '*LAST' INTO KBUFF
C
   51 KBUFF(1) = KSPK(8)
      DO 52 I=1,4
   52 KBUFF(I+1) = KLAST(I)
      DO 53 I=6,80
   53 KBUFF(I) = KBL
      GO TO 16
C
42    FORMAT (80A1)
43    FORMAT (20X,80A1)
44    FORMAT (10X,I5,5X,80A1)
45    FORMAT (48X,23H( B L A N K   C A R D ))
      END
      SUBROUTINE OUTPUT
C     COPYRIGHT 1966, HARRY M. MURPHY, JR.
C
C     THIS SUBROUTINE PRINTS THE INDEX FOR EACH ROUTINE BY SCANNING
C     THE SORTED SYMBOL TABLE AND PRINTING THE INDIVIDUAL REFERENCES.
C
      COMMON/GAMMA/ ITYPE,MAXA,MINA,NSYM
      COMMON/ZETA/ KBUFF(80),KODE,NEXT,NREC
      COMMON/CHI/ KLEAR(8),NROUT,NRT,NKODE,IPAGE
      COMMON/ALPHA/ KBL,KABC(26),KDIG(10),KSPK(13)
      COMMON/PSI/ LOCN,LIST(8191),LISTS(3,2500)
      COMMON/RHO/ KARD(1326)
      COMMON /BETA/ MXCH,MXLI,N15B,LINE,NPAGE,MXLINE
      COMMON /IOTA/ KEY(21)
      COMMON/TAPES/N1,N2,N5,N6
      COMMON/THETA/ KFNUM, KFNIJ(7,90)
C
      DIMENSION INDX(26)
      EQUIVALENCE (KARD(1206),INDX(1))
C
      LOGICAL*4 OUT
C
      IF(LINE.GT.0) CALL PAG(0)
      WRITE (N6,10)
      CALL PAG (2)
      KODE1=LISTS(1,1)
      NROUT=NROUT+1
      NKODE=NKODE+1
      WRITE(N2,14) KODE1,IPAGE
      OUT=.TRUE.
C
      DO 9 I=1,NSYM
      II=LISTS(3,I)
      KODE=LISTS(1,II)
      IF (KODE.GE.MINA.AND.KODE.LE.MAXA) OUT=.FALSE.
      CALL DECODE
      LINK=LISTS(2,II)
C
    2 DO 5 J=1,25,2
      ICELL=LIST(LINK)
      LOCN=ICELL/N15B
      LINK=ICELL-N15B*LOCN
      ITYPE=LOCN/N15B
      IF (OUT) GO TO 4
      GO TO (3,3,3,3,4,4,3,4,4,3,4,4,4,4,3,3,3,4,3,3,4),ITYPE
3     IF (KODE.EQ.KODE1) GO TO 4
      WRITE (N1,14) KODE,KODE1
      NRT=NRT+1
      OUT=.TRUE.
4     LOCN=LOCN-N15B*ITYPE
      INDX(J)=LOCN
      INDX(J+1)=KEY(ITYPE)
      IF (LINK.EQ.0) GO TO 6
5     CONTINUE
      J=25
C
6     JMAX=J+1
      IF (II.NE.0) GO TO 7
      WRITE (N6,11) (INDX(J),J=1,JMAX)
      GO TO 8
    7 CONTINUE
      DO 61 L1=1,10
      IF(KLEAR(1).EQ.KDIG(L1))GO TO 51
   61 CONTINUE
      IF(INDX(2).EQ.KEY(15).OR.INDX(2).EQ.KEY(16).OR.
     X   INDX(2).EQ.KEY(19)) GO TO 50
      IF(INDX(2).NE.KBL) GO TO 52
      DO 63K=1,KFNUM
      NUM=KFNIJ(7,K)
      DO 62 J=1,NUM
      IF(KLEAR(J).NE.KFNIJ(J,K)) GO TO 63
   62 CONTINUE
      IF(KLEAR(NUM+1).EQ.KBL) GO TO 53
   63 CONTINUE
   50 WRITE(N6,54) KLEAR
      CALL PAG(1)
   52 IF(INDX(2).NE.KSPK(8).AND.INDX(2).NE.KEY(11)) GO TO 51
   53 WRITE(N6,15) KSPK(8), KLEAR, (INDX(J),J=1,JMAX)
      GO TO 8
   51 WRITE (N6,12) KLEAR,(INDX(J),J=1,JMAX)
8     CALL PAG (1)
      II = 0
      INDX(2)=KBL
      IF (LINK) 9,9,2
9     CONTINUE
C
      IF(LINE.GE.MXLINE) GO TO 99
      WRITE (N6,13)
      CALL PAG(1)
   99 RETURN
C
   10 FORMAT(5X,6HSYMBOL,5X,21(2H+-),3X,10HREFERENCES,3X,21(2H-+)/1X)
11    FORMAT (14X,13(2X,I4,A2))
12    FORMAT ( 5X,8A1,1H-,13(2X,I4,A2))
   13 FORMAT(1H0,15X,50(2H+-))
14    FORMAT (2I14)
   15 FORMAT(1X,A1,3X,8A1,1H-,13(2X,I4,A2))
   54 FORMAT(13X,14HTHE VARIABLE- ,8A1,29H-IS USED BEFORE IT IS DEFINED)
      END
      SUBROUTINE PAG (N)
C     COPYRIGHT 1966, HARRY M. MURPHY, JR.
C
C     THIS SUBROUTINE DOES THE GENERAL PAGE COUNTING FOR INDEX.
C
      COMMON/DELTA/ JOB(66)
      COMMON /BETA/ MXCH,MXLI,N15B,LINE,NPAGE,MXLINE
      COMMON/TAPES/N1,N2,N5,N6
C
C
      IF(N) 4,2,5
C
5     LINE=LINE+N
      IF(LINE-MXLINE) 4,3,3
2     IF (LINE) 4,4,3
3     NPAGE=NPAGE+1
      WRITE (N6,6) JOB,NPAGE
      LINE=0
4     RETURN
C
    6 FORMAT(1H1,9X,9HI N D E X,12X,66A1,12X,4HPAGE,1X,I4/1X)
      END
      SUBROUTINE SORT
C     COPYRIGHT 1966, HARRY M. MURPHY, JR.
C
C     THIS SUBROUTINE SORTS THE SYMBOL ARRAY IN LIST IN ASCENDING ORDER.
C
      COMMON/GAMMA/ ITYPE,MAXA,MINA,NSYM
      COMMON/PSI/ LOCN,LIST(8191),LISTS(3,2500)
C
      INTEGER*4 LO,HI
C
      IF(NSYM.LE.0) RETURN
C
C     PREPARE THE ADDRESS ARRAY.
C
3     DO 4 I=1,NSYM
4     LISTS(3,I)=I
C
      I=1
5     I=I+I
      IF (I.LE.NSYM) GO TO 5
      M=I-1
C
C     EXECUTE SHELL ADDRESS SORT.
C
6     M=M/2
      IF (M.LT.1) RETURN
      K=NSYM-M
      DO 8 J=1,K
      I=J
7     IM=I+M
      LO=LISTS(3,I)
      HI=LISTS(3,IM)
      IF (LISTS(1,LO).LE.LISTS(1,HI)) GO TO 8
      LISTS(3,I)=HI
      LISTS(3,IM)=LO
      I=I-M
      IF (I.GE.1) GO TO 7
8     CONTINUE
      GO TO 6
      END
      SUBROUTINE SUPER
      COMMON /BETA/ MXCH,MXLI,N15B,LINE,NPAGE,MXLINE
      COMMON/ZETA/ KBUFF(80),KODE,NEXT,NREC
      COMMON/CHI/ KLEAR(8),NROUT,NRT,NKODE,IPAGE
      COMMON/PSI/ LOCN,LIST(8191),LISTS(3,2500)
      COMMON/DELTA/ JOB(66)
      COMMON/ALPHA/ KBL,KABC(26),KDIG(10),KSPK(13)
      COMMON /KAPPA/ KAP(11)
      COMMON/TAPES/N1,N2,N5,N6
C
      DIMENSION LISTX(7845),KODEV(8),KODES(80)
C
      LOGICAL*4 REW,FIRST
C
      EQUIVALENCE (LIST(7847),LISTX(1)), (KBUFF(1),KODES(1))
C
      IF(NROUT.LT.2) RETURN
      REWIND N1
2     NR=NRT
      IF (NR.LT.1) RETURN
      REW=.TRUE.
      IF (NR.LE.7845) GO TO 3
      NRT=NRT-7845
      NR=7845
      REW=.FALSE.
3     READ (N1,22) (LIST(I),LISTX(I),I=1,NR)
      LIST(NR+1)=0
      DO 4 I=1,11
      JOB(I)=KSPK(8)
      JOB(I+11)=KAP(I)
4     JOB(I+22)=KSPK(8)
      JOB(11)=KBL
      JOB(23)=KBL
      DO 5 I=34,66
5     JOB(I)=KBL
      CALL CENTOR
      CALL PAG (51)
      NKODE=NKODE+1
      I=1
      WRITE(N2,22) I, NPAGE
      WRITE (N6,23)
      CALL PAG (2)
C
C     SORT ON SUBROUTINE NAMES, THEN BY VARIABLE NAMES.
C
      I=1
6     I=I+I
      IF (I.LE.NR) GO TO 6
      M=I-1
C
7     M=M/2
      IF (M.LT.1) GO TO 10
      K=NR-M
      DO 9 J=1,K
      I=J
8     IM=I+M
      IF (LISTX(I).LE.LISTX(IM)) GO TO 9
      IB=LISTX(I)
      LISTX(I)=LISTX(IM)
      LISTX(IM)=IB
      IB=LIST(I)
      LIST(I)=LIST(IM)
      LIST(IM)=IB
      I=I-M
      IF (I.GE.1) GO TO 8
9     CONTINUE
      GO TO 7
C
10    LIM=NR
C
11    LIM=LIM-1
      IB=0
      DO 12 I=1,LIM
      IF (LIST(I).LE.LIST(I+1)) GO TO 12
      IB=LIST(I)
      LIST(I)=LIST(I+1)
      LIST(I+1)=IB
      IB=LISTX(I)
      LISTX(I)=LISTX(I+1)
      LISTX(I+1)=IB
12    CONTINUE
      IF (IB) 11,13,11
C
C     PRINT SORTED VARIABLES AND ROUTINES WHICH USE THEM.
C
13    IB=1
14    IF (IB.GT.NR) GO TO 21
      KODEA=LIST(IB)
      KODE=KODEA
      CALL DECODE
      DO 15 I=1,8
15    KODEV(I)=KLEAR(I)
      FIRST=.TRUE.
16    J=0
      IF (IB.GT.NR) GO TO 21
      DO 17 I=1,10
      IF (LIST(IB).NE.KODEA) GO TO 18
      KODE=LISTX(IB)
      CALL DECODE
      IB=IB+1
      DO 17 K=1,8
      J=J+1
17    KODES(J)=KLEAR(K)
   18 IF(J.LE.0) GO TO 14
      IF(FIRST) GO TO 20
      WRITE (N6,24) (KODES(I),I=1,J)
      GO TO 201
20    WRITE (N6,25) KODEV,(KODES(I),I=1,J)
      FIRST=.FALSE.
  201 CALL PAG(1)
      IF(J-80) 14,16,16
C
21    WRITE (N6,26)
      CALL PAG (3)
      IF (.NOT.REW) GO TO 2
      RETURN
C
22    FORMAT (2I14)
23    FORMAT (10X,10HSYMBOL  - ,3(6H======),40H  ROUTINES IN WHICH THE S
     1YMBOL IS USED  ,3(6H======)/1X)
   24 FORMAT(19X,10(2X,8A1))
   25 FORMAT(10X,8A1,1H-,10(2X,8A1))
   26 FORMAT (1H0,9X,18(6H******)/1X)
      END
      SUBROUTINE SYMBOL
C     COPYRIGHT 1966, HARRY M. MURPHY, JR.
C
C     THIS SUBROUTINE INSPECTS KARD STARTING AT KOL+1 FOR THE PRESENCE
C     OF FORTRAN VARIABLES OR STATEMENT NUMBERS.  IF FOUND, THE SYMBOL
C     IS PACKED IN KODE AS A NUMBER WHOSE BASE IS 37.
C
      COMMON/ZETA/ KBUFF(80),KODE,NEXT,NREC
      COMMON/ETA/KMAX,KOL,KRSX,KLSX
      COMMON/RHO/ KARD(1326)
      COMMON/ALPHA/ KBL,KABC(26),KDIG(10),KSPK(13)
      COMMON /BETA/ MXCH,MXLI,N15B,LINE,NPAGE,MXLINE
      DIMENSION KSYM(37)
      EQUIVALENCE (KBL,KSYM(1))
C
C     KLSX = CHARACTER PRECEEDING START OF SEARCH
C     KRSX = CHARACTER FOLLOWING LAST CHARACTER OF SEARCH
C
C     ARRAY KSYM
C             A    B    C    D    E    F    G    H    I    J    K    L
C       (1)  (2)  (3)  (4)  (5)  (6)  (7)  (8)  (9) (10) (11) (12) (13)
C        M    N    O    P    Q    R    S    T    U    V    W    X    Y
C      (14) (15) (16) (17) (18) (19) (20) (21) (22) (23) (24) (25) (26)
C        Z    0    1    2    3    4    5    6    7    8    9
C      (27) (28) (29) (30) (31) (32) (33) (34) (35) (36) (37)
C
C     ARRAY KSPK
C        =    ,    (    /    )    +    -    *    .    $   8/4   &    '
C       (1)  (2)  (3)  (4)  (5)  (6)  (7)  (8)  (9) (10) (11) (12) (13)
C
C     START.  SET UP INITIAL CONDITIONS.
C
1     KODE=0
      NCHAR=0
C
C     SEARCH FOR FIRST SYMBOL.
C
2     KLSX=KARD(KOL)
      KOL=KOL+1
      IF (KOL.GT.KMAX) RETURN
      DO 3 I=2,37
      IF (KARD(KOL).EQ.KSYM(I)) GO TO 4
3     CONTINUE
C
C     TEST FOR VARIABLE RETURN STATEMENT NUMBER
C
      IF(KARD(KOL).NE.KSPK(12)) GO TO 2
      KLSX=KSPK(12)
      GO TO 10
C
C     TEST IF FIRST CHARACTER IS NUMERIC.
C
4     IF (I.GT.27) GO TO 8
C
C     FIRST CHARACTER IS ALPHA.  TEST FOR LEADING PERIOD.
C     IF FIRST ALPHA SYMBOL IS O, CHECK FOR OCTAL CONSTANT.
C
      IF (KLSX.EQ.KSPK(9)) GO TO 18
      IF (I.EQ.16) GO TO 19
C
C     START ALPHA SYMBOL ASSEMBLY.
C
5     NCHAR=NCHAR+1
      IF (NCHAR.GT.MXCH) GO TO 15
      KODE=KODE*37+I-1
      KOL=KOL+1
      IF (KOL.GT.KMAX) GO TO 7
      DO 6 I=2,37
      IF (KARD(KOL).EQ.KSYM(I)) GO TO 5
6     CONTINUE
      KRSX=KARD(KOL)
C
C     PACK OUT KODE WITH ANY NECESSARY BLANKS AND EXIT.
C
7     IF (NCHAR.EQ.MXCH) RETURN
      KODE=KODE*37
      NCHAR=NCHAR+1
      GO TO 7
C
C     FIRST CHARACTER IS NUMERIC.  CHECK FOR LEADING ARITHMETIC
C     OPERATOR OR A DECIMAL POINT.
C
    8 IF(KLSX.EQ.KSPK(1).OR.KLSX.EQ.KSPK(4).OR.KLSX.EQ.KSPK(6).OR.
     1   KLSX.EQ.KSPK(7).OR.KLSX.EQ.KSPK(8).OR.KLSX.EQ.KSPK(9).OR.
     2   KLSX.EQ.KSPK(11)) GO TO 12
C
C     START NUMBER ASSEMBLY.
C
9     IF (I.EQ.28.AND.NCHAR.EQ.0) GO TO 10
      NCHAR=NCHAR+1
      IF (NCHAR.GT.5) GO TO 12
      KODE=KODE*37+I-1
10    KOL=KOL+1
      IF (KOL.GT.KMAX) RETURN
      DO 11 I=28,37
      IF (KARD(KOL).EQ.KSYM(I)) GO TO 9
11    CONTINUE
      KRSX=KARD(KOL)
      IF (KRSX.EQ.KSPK(9)) GO TO 12
      IF(KRSX.EQ.KSPK(4).OR.KRSX.EQ.KSPK(6).OR.KRSX.EQ.KSPK(8).OR.
     1   KRSX.EQ.KSPK(11).OR.KODE.EQ.0) GO TO 1
      IF (KRSX.EQ.KABC(4).OR.KRSX.EQ.KABC(5)) GO TO 12
      RETURN
C
C     SYMBOL IS A NUMERIC CONSTANT.  SCAN TO NEXT SPECIAL CHARACTER
C     WHILE CHECKING FOR D OR E SPECIFICATIONS.
C
12    KOL=KOL+1
      IF (KOL.GE.KMAX) GO TO 23
      IF (KARD(KOL).NE.KSPK(9)) GO TO 13
      IF((KARD(KOL+1).EQ.KSPK(9)).OR.(.NOT.((KARD(KOL+1).EQ.KABC(5).AND.
     X    KARD(KOL+2).NE.KABC(17)).OR.KARD(KOL+1).EQ.KABC(4)))) GO TO 1
      IF (KODE) 1,13,1
13    DO 14 I=1,10
      IF (KARD(KOL).EQ.KDIG(I)) GO TO 12
      IF (KARD(KOL).EQ.KSPK(I+1)) GO TO (1,1,1,1,1,1,1,12,23,1), I
14    CONTINUE
      KRSX=KARD(KOL)
      IF (KRSX.EQ.KABC(4).OR.KRSX.EQ.KABC(5)) KOL=KOL+1
      GO TO 12
C
C     INVALID SYMBOL.  SCAN TO NEXT SPECIAL CHARACTER.
C
   15 KOL=-KOL
      CALL ERROR
C
16    KOL=KOL+1
      IF (KOL.GE.KMAX) GO TO 23
      DO 17 I=1,11
      IF (KARD(KOL).EQ.KSPK(I)) GO TO 1
17    CONTINUE
      GO TO 16
C
C     SKIP OVER LOGICAL OPERATORS OR CONSTANTS.
C
18    KOL=KOL+1
      IF (KOL.GT.KMAX) RETURN
      IF (KARD(KOL).NE.KSPK(9)) GO TO 18
      KARD(KOL)=KSPK(6)
      GO TO 2
C
C     FIRST SYMBOL IS O.  SCAN LINE FOR POSSIBLE OCTAL CONSTANT.
C
19    IB=KOL+1
      DO 21 IB=IB,KMAX
      DO 20 J=1,8
      IF (KARD(IB).EQ.KDIG(J)) GO TO 21
20    CONTINUE
      GO TO 22
21    CONTINUE
      GO TO 23
22    IB=KARD(IB)
      IF(IB.EQ.KSPK(2).OR.IB.EQ.KSPK(4).OR.IB.EQ.KSPK(5).OR.
     X   IB.EQ.KSPK(6).OR.IB.EQ.KSPK(7).OR.IB.EQ.KSPK(8).OR.
     Y   IB.EQ.KSPK(11)) GO TO 12
      GO TO 5
C
C     END OF LINE EXIT.
C
23    KODE=0
      NCHAR=0
      KLSX=KBL
      KRSX=KBL
      RETURN
      END
      SUBROUTINE UPDATE
C     COPYRIGHT 1966, HARRY M. MURPHY, JR.
C
C     THIS SUBROUTINE UPDATES THE SYMBOL TABLE.  NEW SYMBOLS ARE ADDED
C     AS THEY ARE FOUND.  REFERENCES TO PREVIOUSLY FOUND SYMBOLS ARE
C     UPDATED.
C         LISTS(1,N) = SYMBOL
C         LISTS(2,N) = LOCATION OF FIRST ENTRY
C         LISTS(3,N) = LOCATION OF LAST ENTRY
C     WHERE AN ENTRY IS A PACKED WORD CONTAINING
C              TYPE OF STATEMENT(ITYPE)
C              INTERNAL STATEMENT NUMBER(NREC)
C              NEXT ENTRY LOCATION
C         ENTRY = ((ITYPE*N15B)+NREC)*N15B+NEXT
C     NBITS IS DEFINED BY -  N15B = 2**(NBITS-1)
C
      COMMON/ZETA/ KBUFF(80),KODE,NEXT,NREC
      COMMON/PSI/ LOCN,LIST(8191),LISTS(3,2500)
      COMMON /BETA/ MXCH,MXLI,N15B,LINE,NPAGE,MXLINE
      COMMON/GAMMA/ ITYPE,MAXA,MINA,NSYM
      COMMON/TAPES/N1,N2,N5,N6
C
C     CHECK FOR FIRST ENTRY.
C
      IF(NSYM.GT.0) GO TO 3
C
C     THIS IS THE FIRST ENTRY.
C
      NSYM = 1
      J=1
      GO TO 5
C
C     NOT FIRST ENTRY.  SEARCH FOR PREVIOUS MENTION OF SYMBOL.
C
3     DO 4 J=1,NSYM
      IF (LISTS(1,J).EQ.KODE) GO TO 6
4     CONTINUE
C
C     THIS IS FIRST REFERENCE.  MAKE THE INITIAL ENTRY.
C
      NSYM=NSYM+1
      J=NSYM
5     LISTS(1,J)=KODE
      LISTS(2,J)=NEXT
      GO TO 7
C
C     PREVIOUS REFERENCE.  CHECK FOR REDUNDANT ENTRY.
C
6     LINK=LISTS(3,J)
C     UNPACK INTERNAL STATEMENT NUMBER(NREC) FROM ENTRY
      LOCN=LIST(LINK)/N15B
      LOCN=LOCN-(LOCN/N15B)*N15B
      IF (LOCN.EQ.NREC) RETURN
C
C     ADD NEW REFERENCE TO LIST.
C
      LIST(LINK)=LIST(LINK)+NEXT
7     LISTS(3,J)=NEXT
      LIST(NEXT)=(ITYPE*N15B+NREC)*N15B
      NEXT=NEXT+1
C
C     CHECK FOR POSSIBLE SYMBOL TABLE OVERFLOW AND EXIT.
C
      IF(NEXT.LT.MXLI.AND.NSYM.LT.2500) RETURN
C
C     SYMBOL TABLE FULL.  PRINT PARTIAL INDEX, CLEAR SYMBOL TABLE, AND
C     RETURN.
C
      WRITE (N6,8)
      CALL PAG (3)
      CALL SORT
      CALL OUTPUT
      NEXT = 1
      NSYM=0
      NREC=0
      RETURN
C
8     FORMAT (1H0,9X,5H*****,5X,80H****** SYMBOL TABLE FULL.  A PARTIAL
     1INDEX FOR THE ABOVE ROUTINE FOLLOWS. ******/1X)
      END
      SUBROUTINE VAXFIX(KBUFF)
C
C         SUBROUTINE FOR HANDLING FREE FIELD INPUT
C         CONVERT IT TO FORTRAN STANDARD TYPE
C
      DIMENSION KBUFF(80)
      LOGICAL*1 WRKBUF(132),WORK(80)
      ENCODE(80,12000,WORK)KBUFF
12001 FORMAT(1X,132A1)
12000 FORMAT(80A1)
C
C         NOW INITIALIZE WRKBUF AND BUILD NEW RECORD
C
      DO 100 I=1,132
100   WRKBUF(I) = ICHAR(' ')
      ICHR = 0
      ITAB = 0
      LO = 0
      DO 200 I = 1,80
      IF(WORK(I).EQ.ICHAR('	')) GOTO 125
      IF(WORK(I).GE.ICHAR('A').AND.WORK(I).LE.ICHAR('Z')) ICHR=1
      IF(WORK(I).GE.ICHAR('a').AND.WORK(I).LE.ICHAR('z')) ICHR=1
      IF(ITAB.EQ.1.AND.ICHR.EQ.0) GOTO 110
      GOTO 190
C
C        NON ALPHA FOLLOWING TAB
C
110   IF(WORK(I).LE.ICHAR('0').OR.WORK(I).GT.ICHAR('9')) GOTO 190
C     CONTINUATION ?
      LO = 5
      ITAB = 0
      GOTO 190
C
C      TAB CHARACTER
C
125   LO = (LO+8)/8 * 8
      ITAB = 1
      GOTO 200
190   IF(ITAB.EQ.1.AND.WORK(I).NE.ICHAR(' ')) ITAB = 0
      LO = LO + 1
      WRKBUF(LO) = WORK(I)
200   CONTINUE
      DECODE(80,12000,WRKBUF) KBUFF
      RETURN
      END
