!	THE FOLLOWING IS A PROCEDURE USED TO INVOKE EDI(RSX11M VERSION).
!
!	This procedure has the advantage, over direct invocation,
!	that it will accept, as part of the invoking string and in addition
!	to the name of the file to be edited, the word "keep" and a number
!	to be used as a keep count for purging the file after editing.
!
!	EG: EDI [FILENAME.EXT [KEEP N]]
!	(Where EDI:==@SYSCMD:EDI)
!
!	The filename and the keep count are stored in the global
!	symbols OLD_SPEC and KEEP_VERSIONS respectively.  This means
!	that on subsequent invocations of EDI the filename and the
!	keep count need be specified only if a change is desired.
!	Further, if it is desired to default to a particular filename
!	or keep count then these globals can be defined in the login
!	procedure.
!
!	by using this file and TECO.COM, TECO and EDI may be used
!	interchangably with the same conditions prevailing.
!
!		Mr. H. E. Chadwick
!		Department 22810
!		Western Electric Co., Inc.
!		6200 East Broad Street
!		Columbus, Ohio 43213
!			614-868-2093
!
!
$ IF ("''P2'".EQS."KEEP".OR."''P2'".EQS."") THEN GOTO P2_OK
$ WRITE SYS$OUTPUT "INVALID ""KEEP"" PARAMETER"
$ EXIT
$ P2_OK:
$ IF ("''P1'".EQS."") THEN GOTO CHECK_OLD_SPEC
$ USE_P1_SPEC:
$ OLD_SPEC:=='P1'
$ CHECK_OLD_SPEC:
$ IF ("''OLD_SPEC'".NES."") THEN GOTO USE_OLD_SPEC
$ INQUIRE P1 $_File       
$ GOTO USE_P1_SPEC
$ USE_OLD_SPEC:
$ ASSIGN/USER_MODE TT: SYS$INPUT:
$ ASSIGN/USER_MODE TT: SYS$OUTPUT:
$ MCR EDI 'OLD_SPEC'
$ IF (P3.EQS."") THEN GOTO TRY_OLD_KEEP
$ KEEP_VERSIONS=='P3'
$ TRY_OLD_KEEP:
$ KEEP_VERSIONS='KEEP_VERSIONS'+0
$ IF ('KEEP_VERSIONS'.EQS.0)THEN GOTO THE_END
$ PURGE/KEEP='KEEP_VERSIONS' 'OLD_SPEC'
$ THE_END:
$ CLR
